// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_MutexImpl.C,v 1.2 1999/01/13 23:31:22 khalsa Exp $

#include <HPCxx_MutexImpl.h>

HPCxx_MutexImpl::HPCxx_MutexImpl(void) : mutex_()
{
}

// WARNING, think about what this should do
HPCxx_MutexImpl::HPCxx_MutexImpl(const HPCxx_MutexImpl& mutex)
{
  // fix me
  //  mutex_= mutex.mutex_; //Tulip does not have a constructor with argument
}

HPCxx_MutexImpl& HPCxx_MutexImpl::operator=(const HPCxx_MutexImpl& mutex)
{
  //  if (this == &mutex) return *this; // check for self-assignment

  // WARNING, consider what happens when mutex is deleted, will this mutex
  // still work?
  //  mutex_ = mutex.mutex_;
  //
  // FIX ME
  //
  return *this;
}

HPCxx_MutexImpl::~HPCxx_MutexImpl(void)
{
}

int HPCxx_MutexImpl::lock(void)
{
  mutex_.lock();
  return 1;
}

int HPCxx_MutexImpl::unlock(void)
{
  mutex_.unlock();
  return 1;
}
